133	Courier-authlib+Courier-IMAP+Courier-Passd for Qmail	courier-authlibcourier-imapcourier-passd-for-qmail		<p><!-- \	\	@page { margin: 0.79in } \	\	P { margin-bottom: 0.08in } \	\	A:link { so-language: zxx } \	--></p>\
<h1 style="margin-bottom: 0in">COURIER IMAP + COURIERPASSD for Qmail</h1>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in">Courier-imap is (was, until now) the preferred IMAP server to install, because it has built in support for the vchkpw mail user setup that Vpopmail utilizes. (Not true for courier-authlib-0.60.4 and newer). In short, Courier IMAP works with Vpopmail and virtual domains. In addition to installing Courier-imap, we're going to install Courierpassd. Courierpassd is a utility that allows users to change their mailbox passwords remotely.</p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in"><strong>Note: In May 2008 the developer of courier-imap decided to drop support for vpopmail. This support is not there in courier-authlib-0.60.4 and newer.Similarly courier-imap-4.5.0 does not work, if it doesn't find at least courier-authlib-0.60.6 . So you need to down-grade both.</strong></p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in">Reference link: <a href="http://www.mail-archive.com/qmailtoaster-list@qmailtoaster.com/msg22649.html">http://www.mail-archive.com/qmailtoaster-list@qmailtoaster.com/msg22649.html</a></p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in">You must have gdbm-devel installed.</p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">yum -y install gdbm-devel </span><span style="font-family: courier new,courier;"> libtool-ltdl-devel libtool-ltdl postgresql-devel expect</span></p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in">We are going to use latest releases from http://www.courier-mta.org/download.php .</p>\
<p style="margin-bottom: 0in">Courierpassd is available at: http://erresea.arda.homeunix.net/store</p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in">QMR provides courier-authlib-0.55.tar.bz2 . Latest is courier-authlib-0.62.2.tar.bz2  .</p>\
<p style="margin-bottom: 0in">Also QMR package provides courier-imap-4.0.2.tar.bz2 . Whereas the latest is courier-imap-4.5.0.tar.bz2 .</p>\
<p style="margin-bottom: 0in">Also QMR provides courierpassd-1.1.0-RC1 , whereas latest is courierpassd-1.1.2.tar.gz .</p>\
<p style="margin-bottom: 0in"><strong><br /></strong></p>\
<p><strong>Note: The exercise below was done using the latest courier-authlib and courier-imap versions, which you will see further below, failed miserably. The reader following the QMR guide (and this whole series of howtos) is warned again to not get tempted by the newer versions. The latest I could use for courier-authlib was 0.60.2 and the latest I could use for courier-imap was 4.3.0 . So the steps below are equally valid of both old and new versions.</strong></p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">cd /downloads/qmailnew</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">wget http://prdownloads.sourceforge.net/courier/courier-authlib-0.62.2.tar.bz2</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">wget http://prdownloads.sourceforge.net/courier/courier-imap-4.5.0.tar.bz2</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">wget http://www.arda.homeunix.net/store/courierpassd-1.1.2.tar.gz</span></p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in">I am going to build RPMs of these Courier-* files, after putting in the necessary config parameters. The RPM need to be built as ordinary user, for example, kamran.</p>\
<p style="margin-bottom: 0in"> </p>\
<h2 style="margin-bottom: 0in">Courier-authlib:</h2>\
<p style="margin-bottom: 0in">This needs user kamran to be specified in visudo.</p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in">kamran ALL=NOPASSWD: ALL</p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in">After giving it sudo rights, perform the following steps as user Kamran:-</p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">su - kamran</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">[kamran@www qmailnew]$ cp /downloads/qmailnew/courier*   /home/kamran/</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">cd /home/kamran</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">tar xjf courier-authlib-0.62.2.tar.bz2</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">cd courier-authlib-0.62.2</span></p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in">Added the following in the .spec file in the configure section.</p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">--with-authvchkpw --without-authldap  --disable-root-check --with-ssl  --with-redhat</span></p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in">QMR suggests "--with-authchangepwdir=/usr/local/libexec/authlib" to be passed to the configure script. But I could not find it in courier-authlib-0.62.2. (Later discovered that support for  vchkpw is no more there in newer versions of courier-authlib!)</p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in">Note: The following exercise will be useless with courier-authlib-0.62.4. So please use an older version of courier-authlib (older than 0.60.4), to do the install . The following steps were done using newer version and are provided for the sake of completion only.</p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">[kamran@www courier-authlib-0.62.2]$ vi courier-authlib.spec</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">%configure --with-authvchkpw --without-authldap  --disable-root-check --with-ssl --with-redhat</span></p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">cd ..</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;"> </span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">mv courier-authlib-0.62.2.tar.bz2 courier-authlib-0.62.2.tar.bz2.orig</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;"><br /></span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">[kamran@www ~]$ tar cjf courier-authlib-0.62.2.tar.bz2 courier-authlib-0.62.2</span></p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in"> </p>\
<h2 style="margin-bottom: 0in">Courier-authlib can be built and installed using sudo:</h2>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">$ sudo rpmbuild -ta courier-authlib-0.62.2.tar.bz2 </span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">cd /usr/src/redhat/RPMS/x86_64/</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;"><br /></span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">$ sudo rpm -ivh courier-authlib-0.62.2-1.x86_64.rpm courier-authlib-devel-0.62.2-1.x86_64.rpm courier-authlib-mysql-0.62.2-1.x86_64.rpm</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;"><br /></span></p>\
<p style="margin-bottom: 0in">Time to compile/generate RPM for courier-imap as well. Pass the same arguments to its %configure section as well..</p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">cd /home/kamran</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">tar xjf courier-imap-4.5.0.tar.bz2</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">cd courier-imap-4.5.0</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;"> </span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">vi courier-imap.spec </span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">%configure \\</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;"> --with-authvchkpw --without-authldap  --disable-root-check --with-ssl \\</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;"> --with-redhat \\</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;"> %{?xflags: %{xflags}}</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;"><br /></span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">cd ..</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;"><br /></span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">mv courier-imap-4.5.0.tar.bz2 courier-imap-4.5.0.tar.bz2.orig</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">tar cjf courier-imap-4.5.0.tar.bz2 courier-imap-4.5.0 </span></p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in">Time to build the RPM for courier-imap.</p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in"><strong>Note: You cannot build courier-imap as sudo. You will get the following error:</strong></p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">=============================</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">Do not run make check as root</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">=============================</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">make[2]: *** [check-am] Error 1</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">make[2]: Leaving directory `/usr/src/redhat/BUILD/courier-imap-4.3.1/imap'</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">make[1]: *** [check] Error 2</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">make[1]: Leaving directory `/usr/src/redhat/BUILD/courier-imap-4.3.1/imap'</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">make: *** [check-recursive] Error 1</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">error: Bad exit status from /var/tmp/rpm-tmp.6589 (%build)</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;"><br /></span></p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in">So we need to setup a RPM environment in the /home/kamran directory.</p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in">As user kamran:-</p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">mkdir $HOME/rpm/{SOURCES,SPECS,BUILD,SRPMS,RPMS} -p</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">mkdir $HOME/rpm/RPMS/{i386,noarch,x86_64}</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">echo "%_topdir $HOME/rpm" &gt;&gt; $HOME/.rpmmacros</span></p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in">Next,</p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">$ rpmbuild -ta courier-imap-4.5.0.tar.bz2</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">..</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">..</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">Wrote: /home/kamran/rpm/SRPMS/courier-imap-4.5.0-3.src.rpm</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">Wrote: /home/kamran/rpm/RPMS/x86_64/courier-imap-4.5.0-3.x86_64.rpm</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">Wrote: /home/kamran/rpm/RPMS/x86_64/courier-imap-debuginfo-4.5.0-3.x86_64.rpm</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">Executing(%clean): /bin/sh -e /var/tmp/rpm-tmp.72263</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">+ umask 022</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">+ cd /home/kamran/rpm/BUILD</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">+ cd courier-imap-4.5.0</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">+ rm -rf /var/tmp/courier-imap-4.5.0-3-buildroot</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">+ exit 0</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">[kamran@www ~]$</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;"><br /></span></p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">cd $HOME/rpm/RPMS/x86_64</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">sudo rpm -ivh courier-imap-4.5.0-3.x86_64.rpm</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;"><br /></span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">exit # exit back to root user again</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;"><br /></span></p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in">Now, run the following to generate the IMAP certificate:-</p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">/usr/lib/courier-imap/sbin/mkimapdcert</span></p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">[root@www qmailnew]# /usr/lib/courier-imap/sbin/mkimapdcert</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">Generating a 1024 bit RSA private key </span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">.......................................++++++ </span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">.................++++++ </span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">writing new private key to '/usr/lib/courier-imap/share/imapd.pem'</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">----- </span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">1024 semi-random bytes loaded </span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">Generating DH parameters, 512 bit long safe prime, generator 2 </span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">This is going to take a long time </span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">.............+......++*++*++*++*++*++* </span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">subject= /C=US/ST=NY/L=New York/O=Courier Mail Server/OU=Automatically-generated IMAP SSL key/CN=localhost/emailAddress=postmaster@example.com </span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">notBefore=Jun 26 16:02:10 2009 GMT </span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">notAfter=Jun 26 16:02:10 2010 GMT </span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">SHA1 Fingerprint=7A:F6:90:FA:02:2B:45:7F:CF:59:EB:2C:8E:8F:48:03:8C:61:4F:FE </span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">[root@www qmailnew]# </span></p>\
<p> </p>\
<p> </p>\
<br />\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">vi /usr/lib/courier-imap/etc/imapd.cnf</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">change postmaser@example.com an administrative email address postmaster@example.com</span></p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">The file: /usr/lib/courier-imap/etc/imapd</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">Make sure that the following configuration exists: IMAPDSTART=YES</span></p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">~]# grep ^IMAPDSTART /usr/lib/courier-imap/etc/imapd</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">IMAPDSTART=YES</span></p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in">The file: /usr/lib/courier-imap/etc/imapd-ssl</p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in">Make sure that the following configuration exists: IMAPDSSLSTART=YES</p>\
<p style="margin-bottom: 0in">Make sure that the following configuration exists: TLS_CERTFILE=/usr/lib/courier-imap/share/imapd.pem</p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">~]# egrep '^TLS_CERTFILE|^IMAPDSSLSTART' /usr/lib/courier-imap/etc/imapd-ssl</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">IMAPDSSLSTART=YES</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">TLS_CERTFILE=/usr/lib/courier-imap/share/imapd.pem</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">IMAPDSSLSTART=YES</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">IMAPDSTARTTLS=YES</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">IMAP_TLS_REQUIRED=0</span></p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">vi /etc/authlib/authdaemonrc </span></p>\
<p style="margin-bottom: 0in">Around like 27, you should see the "<strong>authmodulelist</strong>" setting. Make sure that "<strong>authvchkpw</strong>" is the only module listed. Like so:</p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">authmodulelist="authvchkpw"</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;"># authmodulelist="authuserdb authpam authpgsql authmysql authcustom authpipe"</span></p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in">Save and exit the file.</p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in">Note: You will not see authvchkpw already in the module list because it was removed in courier-authlib-0.60.4 and newer.  Ideally you should stop here, if this is the case, and download an older version (0.60.2). And perform all the steps again.</p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in">The init.d files would now already be in place, because of RPM installation we did.</p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">[root@www ~]# ls /etc/init.d/courier-*</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">/etc/init.d/courier-authlib </span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">/etc/init.d/courier-imap</span></p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in">Start the courier-authlib service</p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">[root@www ~]# /etc/init.d/courier-authlib start</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">Starting Courier authentication services: authdaemond</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;"><br /></span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">chkconfig --level 35 courier-authlib on</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;"><br /></span></p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in">You should see the authdaemond process, as shown below.</p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">[root@www ~]# ps aux | grep auth</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">root     24157  0.0  0.0   3788   440 ?        S    19:16   0:00 /usr/sbin/courierlogger -pid=/var/spool/authdaemon/pid -start /usr/libexec/courier-authlib/authdaemond</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">root     24158  0.0  0.0  14372   672 ?        S    19:16   0:00 /usr/libexec/courier-authlib/authdaemond</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">root     24159  0.0  0.0  14372   244 ?        S    19:16   0:00 /usr/libexec/courier-authlib/authdaemond</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">root     24160  0.0  0.0  14372   244 ?        S    19:16   0:00 /usr/libexec/courier-authlib/authdaemond</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">root     24161  0.0  0.0  14372   244 ?        S    19:16   0:00 /usr/libexec/courier-authlib/authdaemond</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">root     24162  0.0  0.0  14372   244 ?        S    19:16   0:00 /usr/libexec/courier-authlib/authdaemond</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">root     24163  0.0  0.0  14372   244 ?        S    19:16   0:00 /usr/libexec/courier-authlib/authdaemond</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">root     24166  0.0  0.0  61144   664 pts/0    S+   19:16   0:00 grep auth</span></p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in">And the following output in MAILLOG .</p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">[root@www ~]# tail -f /var/log/maillog</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">...</span></p>\
<span style="font-family: courier new,courier;">Jun 26 19:16:09 www authdaemond: modules="authvchkpw", daemons=5</span>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">Jun 26 19:16:09 www authdaemond: Installing libauthvchkpw</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">Jun 26 19:16:09 www authdaemond: libauthvchkpw.so: cannot open shared object file: No such file or directory</span></p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in"><strong>Note: See the problem! This is because support for authvchkpasswd in versions 0.60.4 and higher is no more there. I need to use the older again.</strong></p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in">In short, I downloaded an older version and successfully installed  courier-authlib-0.60.2 . After performing all of above steps, my /var/log/maillog shows:-</p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">[root@www ~]# tail -f /var/log/maillog</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">...</span></p>\
<p style="margin-bottom: 0in">Jun 26 19:58:00 www authdaemond: modules="authvchkpw", daemons=5</p>\
<p style="margin-bottom: 0in">Jun 26 19:58:00 www authdaemond: Installing libauthvchkpw</p>\
<p style="margin-bottom: 0in">Jun 26 19:58:00 www authdaemond: Installation complete: authvchkpw</p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in"> </p>\
<h2 style="margin-bottom: 0in">To install older versions of courier-authlib and courier-imap, remove the newer versions first:</h2>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">/etc/init.d/courier-authlib stop</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">rpm -qa | grep courier</span></p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">[root@www qmailnew]# rpm -qa | grep courier</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">courier-imap-4.5.0-3</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">courier-authlib-devel-0.62.2-1</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">courier-authlib-0.62.2-1</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">courier-authlib-mysql-0.62.2-1</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;"><br /></span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">[root@www qmailnew]# rpm -e courier-imap courier-authlib-devel courier-authlib courier-authlib-mysql</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">/usr/lib/courier-imap/libexec/imapd.rc: line 55: /usr/sbin/courierlogger: No such file or directory</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">/usr/lib/courier-imap/libexec/imapd-ssl.rc: line 56: /usr/sbin/courierlogger: No such file or directory</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">/usr/lib/courier-imap/libexec/pop3d.rc: line 47: /usr/sbin/courierlogger: No such file or directory</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">/usr/lib/courier-imap/libexec/pop3d-ssl.rc: line 51: /usr/sbin/courierlogger: No such file or directory</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">warning: /usr/lib/courier-imap/etc/imapd.cnf saved as /usr/lib/courier-imap/etc/imapd.cnf.rpmsave</span></p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">[root@www qmailnew]# rpm -qa | grep courier</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">[root@www qmailnew]#</span></p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in"><strong>As evident from the command issued above, nothing related to courier is left on my system. I have RPMS on my older server. I will just rebuild them.</strong></p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">cp /data/backup/downloads/qmailnew/courier* /downloads/qmailnew/</span></p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in">[Do all the installation steps here]</p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in">Start Courier IMAP service:</p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">service courier-imap start</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">chkconfig --level 35 courier-imap on</span></p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">[root@www qmailnew]# nmap localhost</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;"><br /></span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">Starting Nmap 4.11 ( http://www.insecure.org/nmap/ ) at 2009-06-26 20:01 AST</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">Interesting ports on localhost.localdomain (127.0.0.1):</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">Not shown: 1669 closed ports</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">PORT     STATE SERVICE</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">22/tcp   open  ssh</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">53/tcp   open  domain</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">80/tcp   open  http</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">110/tcp  open  pop3</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">143/tcp  open  imap</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">199/tcp  open  smux</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">443/tcp  open  https</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">953/tcp  open  rndc</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">993/tcp  open  imaps</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">995/tcp  open  pop3s</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">3306/tcp open  mysql</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;"><br /></span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">Nmap finished: 1 IP address (1 host up) scanned in 0.063 seconds</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">[root@www qmailnew]#</span></p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in"> </p>\
<h2 style="margin-bottom: 0in">IMPORTANT:</h2>\
<p style="margin-bottom: 0in"><strong>QMAIL has it's own POP3 daemon. And this courier POP3 and POP3S WILL conflict with it. So disable POP3 and POP3S in Courier. </strong></p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in"><strong>Note: This is from QMR and I do not agree. Basically you will have to maintain two mechanisms to manage which will be difficult for you. It is rather better to disable qmail-pop3d and use pop3 and imap , both, from courier. Anyway, in this howto it is done as per QMR guide. In my next howto, this issue is being taken care of. Also In next howto, Courier is being replaced by DoveCot.</strong></p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">vi /usr/lib/courier-imap/etc/pop3d</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">...</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">POP3DSTART=NO</span></p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">vi /usr/lib/courier-imap/etc/pop3d-ssl</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">...</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">POP3DSSLSTART=NO</span></p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">[root@www ~]# service courier-imap stop</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">Stopping Courier-IMAP server: imap imap-ssl pop3 pop3-ssl</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;"><br /></span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">[root@www ~]# service courier-imap start</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">Starting Courier-IMAP server: imap imap-ssl</span></p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in">Or may be rename the files:</p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">cd /usr/lib/courier-imap/etc/</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">mv pop3d pop3d.disabled</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">mv pop3d-ssl pop3d-ssl.disabled</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;"><br /></span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">[root@www qmail-scanner-2.04]# service courier-imap stop</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">Stopping Courier-IMAP server: imap imap-ssl pop3 pop3-ssl</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;"><br /></span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">[root@www qmail-scanner-2.04]# service courier-imap start</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">Starting Courier-IMAP server: imap imap-ssl</span></p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in"> </p>\
<h2 style="margin-bottom: 0in">COURIERPASSD:</h2>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">[root@www ~]# find / -name courierauthconfig</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">/home/akhan/rpm/BUILD/courier-authlib-0.60.2/courierauthconfig</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">/usr/bin/courierauthconfig</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;"><br /></span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">[root@www ~]# find / -name courierauth.h</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">/home/akhan/rpm/BUILD/courier-authlib-0.60.2/courierauth.h</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">/home/akhan/downloads/courier-authlib-0.60.2/courierauth.h</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">/usr/include/courierauth.h</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">/downloads/qmailrocks/courier-authlib-0.55/courierauth.h</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">[root@www ~]# </span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;"><br /></span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">cd /downloads/qmailnew</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">tar xzf courierpassd-1.1.2.tar.gz</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;"><br /></span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">cd /downloads/qmailnew/courierpassd-1.1.2 </span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">./configure</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">make &amp;&amp; make install</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;"><br /></span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">echo "courierpassd 106/tcp #for /etc/xinetd.d/courierpassd" &gt;&gt; /etc/services</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">echo "courierpassd 106/tcp #for /etc/xinetd.d/courierpassd" &gt;&gt; /usr/share/nmap/nmap-services</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;"><br /></span></p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in">Add this to xinetd. You must have xinet rpm installed on the system.</p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">cat &gt; /etc/xinetd.d/courierpassd &lt;&lt; EOF</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">service courierpassd</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">{</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">port = 106</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">socket_type = stream</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">protocol = tcp</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">user = root</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">server = /usr/local/sbin/courierpassd</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">server_args = -s imap</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">wait = no</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">only_from = 127.0.0.1</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">instances = 4</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">disable = no</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">}</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">EOF</span></p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">service xinetd restart</span></p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">[root@www courierpassd-1.1.2]# nmap localhost</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;"><br /></span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">PORT     STATE SERVICE</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">21/tcp   open  ftp</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">22/tcp   open  ssh</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">80/tcp   open  http</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">106/tcp  open  pop3pw ----------------------------&gt; courierpassd</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">110/tcp  open  pop3</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">143/tcp  open  imap</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">199/tcp  open  snmp</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">443/tcp  open  https</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">993/tcp  open  imaps</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">995/tcp  open  pop3s</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">3306/tcp open  mysql</span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;"><br /></span></p>\
<p style="margin-bottom: 0in"><span style="font-family: courier new,courier;">Nmap finished: 1 IP address (1 host up) scanned in 0.233 seconds</span></p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in"> </p>\
<p style="margin-bottom: 0in"><strong>Courier finished!</strong></p>		1	11	0	34	2009-08-16 11:59:10	64		2010-12-26 11:52:19	63	0	0000-00-00 00:00:00	2009-08-16 11:59:10	0000-00-00 00:00:00			show_title=\
link_titles=\
show_intro=\
show_section=\
link_section=\
show_category=\
link_category=\
show_vote=\
show_author=\
show_create_date=\
show_modify_date=\
show_pdf_icon=\
show_print_icon=\
show_email_icon=\
language=\
keyref=\
readmore=	2	0	33	courier-authlib, courier-imap, courierpassd, qmail		0	16624	robots=\
author=Muhammad Kamran Azeem
